import keras
# -*- encoding:utf-8 -*-
import numpy as np
from keras.models import Sequential
from keras.layers import Dense,Dropout
import random
from keras.models import load_model

def read_data(path):
    train_x=[]
    train_y=[]
    lines = []
    with open(path) as f:
        for x in range(20000):
            lines.append(eval(f.readline().strip()))
    random.shuffle(lines)
    lines = lines[:8000]
    d=int(0.95*len(lines))

    size = len(lines[0])
    train_x=[s[:size - 2] for s in lines[0:d]]
    train_y=[s[size-1] for s in lines[0:d]]
    test_x=[s[:size - 2] for s in lines[d:]]
    test_y=[s[size-1] for s in lines[d:]]
    return np.array(train_x),np.array(train_y),np.array(test_x),np.array(test_y)

train_x,train_y,test_x,test_y=read_data("D:\\data\\quantization\\stock6.log")

model = Sequential()
model.add(Dense(units=425, input_dim=166,  activation='relu'))
model.add(Dense(units=325, activation='relu'))
model.add(Dense(units=325, activation='relu'))
model.add(Dropout(0.2))
model.add(Dense(units=225, activation='relu'))
model.add(Dense(units=225, activation='relu'))
model.add(Dense(units=225, activation='relu'))
model.add(Dense(units=225, activation='relu'))
model.add(Dropout(0.2))
model.add(Dense(units=225, activation='relu'))
model.add(Dense(units=125, activation='relu'))
model.add(Dropout(0.2))
model.add(Dense(units=125, activation='relu'))
model.add(Dense(units=166, activation='relu'))
# model.add(Dropout(0.2)(Dense(units=225, activation='relu')))
model.add(Dense(units=8, activation='softmax'))
model.compile(loss='categorical_crossentropy', optimizer="adam",metrics=['accuracy'])

print("Starting training ")
h=model.fit(train_x, train_y, batch_size=32, epochs=16, shuffle=True)
score = model.evaluate(test_x, test_y)
print(score)
print('Test score:', score[0])
print('Test accuracy:', score[1])

path="model_seq.h5"
model.save(path)
model=None


model=load_model(path)
result=model.predict(test_x)
print(result)
print(test_y)